#version 410
precision highp float;

//#define COLOR_TEST 1

layout(vertices = 4) out;

//in vec4 vScreenPosition[];
in vec2 vTexUV[];

//out vec4 cScreenPosition[];
out vec2 cTexUV[];
#ifdef COLOR_TEST
	out vec3 cTestColor[];
#endif

void main()
{
	//cScreenPosition[gl_InvocationID] = vScreenPosition[gl_InvocationID];
	cTexUV[gl_InvocationID] = vTexUV[gl_InvocationID];
	
	#ifdef COLOR_TEST
		if(gl_InvocationID == 0)
			cTestColor[gl_InvocationID] = vec3(1.0, 1.0, 0.0); //gelb
		else if(gl_InvocationID == 1)
			cTestColor[gl_InvocationID] = vec3(0.0, 0.0, 1.0); //blau
		else if(gl_InvocationID == 2)
			cTestColor[gl_InvocationID] = vec3(0.0, 1.0, 0.0); //grn
		else if(gl_InvocationID == 3)
			cTestColor[gl_InvocationID] = vec3(1.0, 0.0, 0.0); // rot
		else
			cTestColor[gl_InvocationID] = vec3(0.0, 1.0, 1.0); // trkis
	#endif
	

	if(gl_InvocationID == 0)
	{
		/*
		vec3 p0 = vScreenPosition[0].xyz / vScreenPosition[0].w;
		vec3 p1 = vScreenPosition[1].xyz / vScreenPosition[1].w;
		vec3 p2 = vScreenPosition[2].xyz / vScreenPosition[2].w;

		p0.z *= 200.0;
		p1.z *= 200.0;
		p2.z *= 200.0;

		float out0 = length(p1 - p2) * 25.0;
		float out1 = length(p0 - p2) * 25.0;
		float out2 = length(p0 - p1) * 25.0;

		gl_TessLevelOuter[0] = out0;
		gl_TessLevelOuter[1] = out1;
		gl_TessLevelOuter[2] = out2;

		gl_TessLevelInner[0] = max(max(out0, out1), out2) * 1.5;
		*/

		float mapRes = 32;
		float outer = mapRes;
		float inner = mapRes;

		gl_TessLevelOuter[0] = outer;
		gl_TessLevelOuter[1] = outer;
		gl_TessLevelOuter[2] = outer;
		gl_TessLevelOuter[3] = outer;

		gl_TessLevelInner[0] = inner;
		gl_TessLevelInner[1] = inner;
	}
}