#version 150
precision highp float;

uniform vec3 diffuseColor;
uniform sampler2D depthTexture;

in vec3 position;

out vec4 fragColor;

void main()
{
	float alpha;
	vec2 depthUV = (position.xy + 1.0f) / 2.0f;
	float depth = texture2D(depthTexture, depthUV).r;
	if(gl_FragCoord.z < depth)
	{
		alpha = 1.0f;
	}
	else
	{
		alpha = 0.0f;
	}
	//gl_FragCoord.
	//gl_FragDepth.
	//vec2 depthUV = (gl_FragCoord.xy + 1.0f) / 2.0f;
	fragColor = vec4(diffuseColor, 1.0f) * alpha;
	//fragColor = vec4(depth, depth, depth, 1.0f);
}