#version 150
precision highp float;

uniform mat4 cameraMatrix;

in vec4 vertex;

out vec3 position;

void main()
{
	vec4 postionTemp = cameraMatrix * vertex;
	position = vec3(postionTemp / postionTemp.w);
	gl_Position = postionTemp;
}